From 97408eed57cd17f92d5498587f2b65c63c3eebed Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 23 2020 03:27:29 +0000
Subject: [PATCH 345/2232] Merge pull request #141 from dtolnay/sized


Improve span of unsized opaque type error
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 8b3602a..3189bff 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -20,20 +20,15 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
 
     let mut expanded = TokenStream::new();
     let mut hidden = TokenStream::new();
-    let mut has_rust_type = false;
 
     for api in &apis {
         if let Api::RustType(ety) = api {
             expanded.extend(expand_rust_type(ety));
-            if !has_rust_type {
-                hidden.extend(quote!(
-                    const fn __assert_sized<T>() {}
-                ));
-                has_rust_type = true;
-            }
             let ident = &ety.ident;
             let span = ident.span();
-            hidden.extend(quote_spanned!(span=> __assert_sized::<#ident>();));
+            hidden.extend(quote_spanned! {span=>
+                let _ = ::std::ptr::read::<#ident>;
+            });
         }
     }
 
diff --git a/tests/ui/opaque_not_sized.stderr b/tests/ui/opaque_not_sized.stderr
index e93a546..0baa70a 100644
--- a/tests/ui/opaque_not_sized.stderr
+++ b/tests/ui/opaque_not_sized.stderr
@@ -1,12 +1,9 @@
 error[E0277]: the size for values of type `str` cannot be known at compilation time
- --> $DIR/opaque_not_sized.rs:4:14
-  |
-1 | #[cxx::bridge]
-  | -------------- required by this bound in `ffi::_::__assert_sized`
-...
-4 |         type TypeR;
-  |              ^^^^^ doesn't have a size known at compile-time
-  |
-  = help: within `TypeR`, the trait `std::marker::Sized` is not implemented for `str`
-  = note: to learn more, visit <https://doc.rust-lang.org/book/ch19-04-advanced-types.html#dynamically-sized-types-and-the-sized-trait>
-  = note: required because it appears within the type `TypeR`
+   --> $DIR/opaque_not_sized.rs:4:14
+    |
+4   |         type TypeR;
+    |              ^^^^^ doesn't have a size known at compile-time
+    |
+    = help: within `TypeR`, the trait `std::marker::Sized` is not implemented for `str`
+    = note: to learn more, visit <https://doc.rust-lang.org/book/ch19-04-advanced-types.html#dynamically-sized-types-and-the-sized-trait>
+    = note: required because it appears within the type `TypeR`

